﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win

Public Class Form1

    Private index As Int32

    Private Sub btnGo_Click(sender As Object, e As EventArgs) Handles btnGo.Click

        Try
            Me.CreateDataSet()
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.ToString())
        End Try

    End Sub

    Private Sub CreateDataSet()

        Dim ds As New DataSet()
        Dim dt As New DataTable("Account")
        Dim dr As DataRow

        With dt.Columns
            .Add("MemberNumber", GetType(Int64))
            .Add("CurrentBalance", GetType(Decimal))
        End With

        With ds
            .Tables.Add(dt)
        End With

        With ds.Tables(0)
            dr = ds.Tables(0).NewRow()
            With dr
                .Item("MemberNumber") = 200
                .Item("CurrentBalance") = 10.25
            End With
            .Rows.Add(dr)

            dr = ds.Tables(0).NewRow()
            With dr
                .Item("MemberNumber") = 201
                .Item("CurrentBalance") = 11.25
            End With
            .Rows.Add(dr)

        End With

        ds.AcceptChanges()

        index = 0

        grdAccounts.DataSource = ds
        FormatGrid()

    End Sub

    Private Sub FormatGrid()

        For Each ocolumn As Infragistics.Win.UltraWinGrid.UltraGridColumn In grdAccounts.DisplayLayout.Bands(0).Columns
            With ocolumn
                Select Case .Key
                    Case "CurrentBalance"
                        .Header.Caption = "Current Bal"
                        .CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
                        .Width = 81
                        .Format = "$#,###,##0.00"
                End Select
            End With
        Next

    End Sub

    Private Sub grdAccounts_InitializeRow(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs) Handles grdAccounts.InitializeRow

        Dim band As UltraGridBand = Me.grdAccounts.DisplayLayout.Bands(0)
        Dim defaultEditorOwnerSettings As New DefaultEditorOwnerSettings()
        Dim format As String = "$#,###,##0.00"

        If index = 1 Then
            format = "$************"
        End If

        defaultEditorOwnerSettings.Format = format

        Dim defaultEditorOwner As New DefaultEditorOwner(defaultEditorOwnerSettings)
        Dim editorWithText As New EditorWithText(defaultEditorOwner)

        e.Row.Cells("CurrentBalance").Editor = editorWithText

        index += 1
    End Sub
End Class
